/*
 * Copyright (C) 2005 - 2011, Roni Zaharia
 */

/// \page CPPTestApplications C++ Test Applications
/// The C++ test applications can be downloaded from www.roniza.com/downloads
/// \section CPPCreateKeyObjectSelectionExample C++ Create Key Object Selection SR Document Example
/// C++ DICOM Key Object Selection Document Example (Key Images)
/// This example shows how to use the IDCXKIN interface to create a DICOM Structured Report of type
/// Key Object Selection Object (AKA Key Images Notes)
/// The input parameters are a list of DICOM file names that we simply add to the Key Images object.
/// Then we simply export the object and save it to disk.

#import "../rzdcx.tlb" rename_namespace ("rzdcxLib")
using namespace rzdcxLib;

int main(int argc, char* argv[])
{
	if (argc > 0) {
		CoInitialize(NULL);
		{
			IDCXKINPtr kos;
			for (int i=1; i<argc; i++) {
				kos->AddFromFile(argv[i]);
			}
			kos->Object->saveFile("kin.dcm");
		}
		CoUninitialize();
	}
}

