/*
 * Copyright (C) 2011, Roni Zaharia
 */

#include <string>
#include <list>

using namespace std;

class DICOMIZERAPI {

	string _myAETitle;

public:

	struct DICOMApplication {
		string AETitle;
		string HostOrIPAddress;
		unsigned short port;
	};

	typedef list<string> Images;
	typedef list<string> ReportScreenshots;

	struct ExamInfo {
		string AccessionNumber;
		string Date; 
		string PatientID;
		string FirstNameEng;
		string LastNameEng;
		string FirstNameHeb;
		string LastNameHeb;
		string FatherNameHeb;
		string ExamTypeEng;
		string ExamTypeHeb;
		string LoginDoctor;
		string Manufecturer; /// This is constant, no?
		Images images;
		ReportScreenshots report;

		bool readText(const char* filename);
	};


	DICOMIZERAPI(
		const string& myAETitle ///< The AE Title of the application as defined in the PACS (requesting AE Title)
		);

	~DICOMIZERAPI();

	enum OpResultCode {
		Successful = 0,
		IntermitentFailure = 1, ///< Try again later
		PermanentFailure = 2 ///< Something is wrong, check your data
	};

	struct OpResult {
		OpResultCode code;
		string errorMessage;
	};

	OpResult SaveAsDICOM(
		ExamInfo& examInfo,
		string saveInDir
		);

	OpResult SendFolder(
		DICOMApplication& destination, ///< The info of the destination DICOM Application
		string dirToSend ///< Path to the folder where the files are
		);

};
