/*
 * Copyright (C) 2005 - 2011, Roni Zaharia
 */

/// \page CPPTestApplications C++ Test Applications
/// The C++ test applications can be downloaded from www.roniza.com/downloads
/// \section CPPMPPSSCUExample C++ Modality Performed Procedure Step (MPPS) SCU Example
/// This example shows how to create a Modality Performed Procedure Step client (SCU)

/// Dll import from the current directory
#import "../rzdcx.tlb" rename_namespace ("rzdcxLib")

using namespace rzdcxLib;

int main(int argc, char* argv[])
{
	CoInitialize(NULL);

	_bstr_t sopInstanceUID;

	{

		IDCXOBJPtr ssas(__uuidof(DCXOBJ));
		IDCXELMPtr e(_uuidof(DCXELM));

		///
		/// Scheduled Step Attributes Sequence
		/// 

		e->Init((int)studyInstanceUID);
		e->Value = "1.2.3.4.5"; /// Type 1 (Mandatory)
		ssas->insertElement(e); 

		e->Init((int)ReferencedStudySequence);
		ssas->insertElement(e); /// Type 2 (0 length is OK)
		IDCXOBJPtr obj(__uuidof(DCXOBJ));

		e->Init((int)AccessionNumber);
		ssas->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)RequestedProcedureID);
		ssas->insertElement(e); /// Type 2 (0 length is OK)
		/// 
		e->Init((int)RequestedProcedureDescription);
		ssas->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)ScheduledProcedureStepID);
		ssas->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)ScheduledProcedureStepDescription);
		ssas->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)ScheduledProtocolCodeSequence);
		ssas->insertElement(e); /// Type 2 (0 length is OK)

		IDCXOBJIteratorPtr sq(__uuidof(DCXOBJIterator));
		sq->Insert(ssas);

		e->Init((int)ScheduledStepAttributesSequence);
		e->PutValue( &_variant_t( (IUnknown*)sq, false ) );

		///
		/// Performed Procedure Step
		/// 

		IDCXOBJPtr pps(__uuidof(DCXOBJ));
		pps->insertElement(e);

		e->Init((int)PatientsName);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)patientID);
		pps->insertElement(e); /// Type 2 (0 length is OK)
		/// 
		e->Init((int)PatientsBirthDate);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PatientsSex);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)ReferencedPatientSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProcedureStepID);
		e->Value = 123;
		pps->insertElement(e);

		e->Init((int)PerformedStationAETitle);
		e->Value = "RZDCX";
		pps->insertElement(e);

		e->Init((int)PerformedStationName);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedLocation);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProcedureStepStartDate);
		e->Value = "20090101";
		pps->insertElement(e);

		e->Init((int)PerformedProcedureStepStartTime);
		e->Value = "10:10:10";
		pps->insertElement(e);

		e->Init((int)PerformedProcedureStepStatus);
		e->Value = "IN PROGRESS";
		pps->insertElement(e);

		e->Init((int)PerformedProcedureStepDescription);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProcedureTypeDescription);
		pps->insertElement(e); /// Type 2 (0 length is OK) 

		e->Init((int)ProcedureCodeSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProcedureStepEndDate);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProcedureStepEndTime);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)Modality);
		e->Value = "US";
		pps->insertElement(e);

		e->Init((int)StudyID);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedProtocolCodeSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init((int)PerformedSeriesSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		///
		/// Send the N-CREATE
		/// 

		IDCXREQPtr req(__uuidof(DCXREQ));
		sopInstanceUID = req->MPPS_Create("RZDCX", "JDICOM", "localhost", 6104, pps);

	}

	{
		IDCXOBJPtr ssas(__uuidof(DCXOBJ));
		IDCXELMPtr e(__uuidof(DCXELM));

		///
		/// Performed Procedure Step
		/// 

		IDCXOBJPtr pps(__uuidof(DCXOBJ));
		e->Init(PerformedProcedureStepEndDate);
		e->Value = "20090102";
		pps->insertElement(e);

		e->Init(PerformedProcedureStepEndTime);
		e->Value = "101012";
		pps->insertElement(e);

		e->Init(PerformedProcedureStepStatus);
		e->Value = "COMPLETED";
		pps->insertElement(e);

		e->Init(PerformedProcedureStepDescription);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init(PerformedProcedureTypeDescription);
		pps->insertElement(e); /// Type 2 (0 length is OK) 

		e->Init(ProcedureCodeSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		e->Init(PerformedProtocolCodeSequence);
		pps->insertElement(e); /// Type 2 (0 length is OK)

		/// 
		/// Series Sequence
		/// 
		IDCXOBJPtr series_item(__uuidof(DCXOBJ));
		e->Init(PerformingPhysiciansName);
		series_item->insertElement(e);

		e->Init(ProtocolName);
		e->Value = "SOME PROTOCOL";
		series_item->insertElement(e);

		e->Init(OperatorsName);
		series_item->insertElement(e);

		e->Init(seriesInstanceUID);
		e->Value = "1.2.3.4.5.6";
		series_item->insertElement(e);

		e->Init(SeriesDescription);
		series_item->insertElement(e);

		e->Init(RetrieveAETitle);
		series_item->insertElement(e);

		e->Init(ReferencedImageSequence);
		series_item->insertElement(e);

		e->Init(ReferencedNonImageCompositeSOPInstanceSequence);
		series_item->insertElement(e);

		IDCXOBJIteratorPtr series_sq(__uuidof(DCXOBJIterator));
		series_sq->Insert(series_item);
		e->Init(PerformedSeriesSequence);
		e->PutValue( &_variant_t( (IUnknown*)series_sq, false ) );
		pps->insertElement(e);

		///
		/// Send the N-SET
		/// 

		IDCXREQPtr req(__uuidof(DCXREQ));
		req->MPPS_Set("RZDCX", "JDICOM", "localhost", 6104, pps, sopInstanceUID);
	}

	CoUninitialize();
}

