/*
 * Copyright (C) 2005 - 2011, Roni Zaharia
 */

/// \page MTTA Multi-Threaded Test Applications
/// The C++ test applications can be downloaded from www.roniza.com/downloads
/// \section CPPMultithreadedServerDemo C++ Multi-Threaded Storage SCP Demo
/// C++ Multithreaded Server Demo
/// This is a test application for the association accepter class.
/// The application listens on a port
/// The Sink class is the way to implement the event callbacks from
/// the dll.
/// This demo is multithreaded and it creates a thread to wait on every connection
/// and process it so connections can be processed simultaniously.

#include "stdafx.h"
#include "CPPMultithreadedServerExample.h"
#include <stdio.h>
#include <time.h>
#include <afx.h>
#include <string>
#include "Sink.h"
#include "AssocThread.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/// The one and only application object

CWinApp theApp;

using namespace std;

static bool isRunning = true;

struct Stopper 
{
    static void Stop() { isRunning = false; }
};

HANDLE ConsoleEventManager<Stopper>::m_endEvent;

class MoveThread : public rz::thread
{
public:
    virtual void run();
};

void MoveThread::run() 
{
	Sleep(1000);

	CoInitialize(NULL);


	{
		IDCXREQPtr req(__uuidof(DCXREQ));

		//IConnectionPointContainerPtr ptrConPntCnt = (IDispatch*)req;
		//IConnectionPointPtr ptrCon;
		//IUnknown* pHandler = NULL;
		//DWORD dwCookie;

		//if(ptrConPntCnt != NULL)
		//{
  //          /// Connect the acceptor events to the Sink class that handles
  //          /// them.
		//	ptrConPntCnt->FindConnectionPoint(__uuidof(IDCXREQEvents),&ptrCon);
	 //                   
		//	CSink *pSink = new CSink();

		//	pHandler = pSink->GetInterface(&IID_IUnknown);
		//	ptrCon->Advise(pHandler,&dwCookie);

		try {
			req->MoveSeries("RZDCX", "JDICOM", "localhost", 5104, "RZDCX", "29", 
				"1.3.46.670589.33.1.17971886402193657411.309713837059410185",
				"1.3.46.670589.33.1.39973255682142838344.25804774183403708157");
			req.Release();
		} catch (_com_error& e) {
			printf("%s", _bstr_t(e.Description()));
		}
			//ptrCon->Unadvise(dwCookie);
			//ptrCon.Release();
			//ptrConPntCnt.Release();
			//delete pSink;
		//}
	}

	CoUninitialize();
}


/// \example CPPMultithreadedServerExample.cpp C++ Multi-Threaded Storage SCP Example
/// This is a simple example of how RZDCX can be used in a multithreaded application
/// In this case the application waits for incomming connections and handles each association
/// on a separate thread.
int main(int argc, char* argv[])
{
    // Create the console event manager so that if the
    // program was interrupted in the middle of the loop,
    // it will finish properly (Allways create it in the beggining
    // of the program)
    ConsoleEventManager<Stopper> cem;

    int nRetCode = 0;

	MoveThread move;
	move.start();

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		printf("Fatal Error: MFC initialization failed\n");
		nRetCode = 1;
	}
	else
	{
		while (isRunning)
        {
            // Create and start a new thread to wait for a connection
            AssocThread thread;
            thread.start();

            // Create an event to know when a connection has been
            // established
            HANDLE hEvent = thread.createAndGetEvent();

            // Wait on the event, when a connection is
            // established we need to create another
            // thread and start waiting for another connection
            WaitForSingleObject(hEvent, INFINITE);
            CloseHandle(hEvent);
        }
	}

	return nRetCode;
}
