// Sink.cpp : implementation file
//

#include "stdafx.h"
#include "CPPStorageSCPExample.h"
#include "Sink.h"


// CSink

IMPLEMENT_DYNAMIC(CSink, CCmdTarget)


CSink::CSink()
{
	EnableAutomation();
}

CSink::~CSink()
{
}


void CSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CSink, CCmdTarget)
END_MESSAGE_MAP()


BEGIN_DISPATCH_MAP(CSink, CCmdTarget)
	DISP_FUNCTION(CSink, "OnCommitResult", OnCommitResult, VT_I4, VTS_BOOL VTS_BSTR VTS_BSTR VTS_BSTR)
    DISP_FUNCTION(CSink, "OnConnection", OnConnection, VT_I4, VTS_BSTR VTS_BSTR VTS_BSTR VTS_PBOOL)
	DISP_FUNCTION(CSink, "OnStoreSetup", OnStoreSetup, VT_I4, VTS_PBSTR)
	DISP_FUNCTION(CSink, "OnStoreDone", OnStoreDone, VT_I4, VTS_BSTR VTS_BOOL VTS_PBOOL)
	DISP_FUNCTION(CSink, "OnTimeout", OnTimeout, VT_I4, VTS_NONE)
END_DISPATCH_MAP()

// Note: we add support for IID_ISink to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {4AF0BAFE-5575-4381-9CC9-59A0156D65B2}
static const IID IID_ISink =
{ 0x4AF0BAFE, 0x5575, 0x4381, { 0x9C, 0xC9, 0x59, 0xA0, 0x15, 0x6D, 0x65, 0xB2 } };

BEGIN_INTERFACE_MAP(CSink, CCmdTarget)
	INTERFACE_PART(CSink, __uuidof(IDCXACCEvents), Dispatch)
END_INTERFACE_MAP()


// CSink message handlers
HRESULT CSink::OnCommitResult(VARIANT_BOOL status, BSTR transactionUID, BSTR succeededInstances, BSTR failedInstances)
{
	USES_CONVERSION;
	mTID =  T2A((LPTSTR)transactionUID);
	mSList  = T2A((LPTSTR)succeededInstances);
	mFList  = T2A((LPTSTR)failedInstances);

	return 0;
}

HRESULT CSink::OnConnection(BSTR calling, BSTR called, BSTR host, VARIANT_BOOL *accept_connection)
{
	VARIANT_BOOL response = -1;
	USES_CONVERSION;

	char* callingAE = T2A((LPTSTR)calling);
	char* calledAE = T2A((LPTSTR)called);
	char* h = W2A(host);

	printf("%s, %s, %s", callingAE, calledAE, h);

	*accept_connection = response;
	return 0;
}

HRESULT CSink::OnStoreSetup(BSTR *out)
{
    static int filecount=0;
    char fname[20];
    sprintf(fname, ".\\dcm%04d.dcm", ++filecount);
	USES_CONVERSION;
    *out = A2BSTR(fname);
	return 0;
}

HRESULT CSink::OnStoreDone(BSTR filename,
				VARIANT_BOOL storage_status,
				VARIANT_BOOL *accept_storage)
{
	USES_CONVERSION;
	char* fname = W2A(filename);
	
	VARIANT_BOOL b = -1;
	accept_storage = &b;
	printf("%s", fname);
	return 0;
}

HRESULT CSink::OnTimeout()
{
	
	return 0;
}