/*
 * Copyright (C) 2005 - 2011, Roni Zaharia
 */

using System;
using System.Collections.Generic;
using System.Text;
using rzdcxLib;
using System.Runtime.InteropServices;

namespace DicomObjectExample
{
    /// <summary>
    /// \example SequenceExample.cs
    /// This Example show how to create a sequence tag and add it to a DICOM Object.
    /// The example creates a referenced SOP Instances Sequence, that is used in many
    /// DICOM services such as Storage Commitment and others.
    /// </summary>
    class SequenceExample
    {
        DCXOBJ CreateReferencedImageSequence()
        {
            ///  First create an object iterator to hold the sequence items
            DCXOBJIterator it = new DCXOBJIterator();
            
            /// Create an element
            DCXELM e = new DCXELM();
     
            /// Then Create an object for the first item.
            DCXOBJ currObj = new DCXOBJ();

            for (int i = 1; i<=10; i++)
            {
                /// Set the SOP Class UID, for example CT
                e.Init(0x00081150);
                e.Value = "1.2.840.10008.5.1.4.1.1.2";
                currObj.insertElement(e);

                /// Set the SOP Instance UID
                e.Init(0x00081155);
                e.Value = "1.2.3.4.5.6." + i.ToString();
                currObj.insertElement(e);

                /// Add the item to the sequence
                it.Insert(currObj);
            }

            /// Assign the sequence to a Referenced Image Sequence Element
            e.Init(0x00081199);
            e.Value = it;
            DCXOBJ theObj = new DCXOBJ();
            theObj.insertElement(e);

            Marshal.ReleaseComObject(it);
            Marshal.ReleaseComObject(e);
            Marshal.ReleaseComObject(currObj);

            return theObj;
        }
    }
}
