/*
 * Copyright (C) 2005 - 2011, Roni Zaharia
 */

/// \page CSTestApplications C# Test Applications
/// The C# test applications can be downloaded from www.roniza.com/downloads
/// \section StorageSCUDemo Storage SCU Demo
/// Storage SCU Demo
/// This example shows how to send files to a remote ae

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using rzdcxLib;
using System.Runtime.InteropServices;

/// \example StorageSCUExampleForm.cs
/// A C# DICOM Storage SCU (C-STORE) Example
namespace StorageSCUExample
{
    public partial class StorageSCUExampleForm : Form
    {
        public StorageSCUExampleForm()
        {
            InitializeComponent();
        }

        private void BrowseBtn_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                for (int i = 0; i < openFileDialog.FileNames.Length; i++)
                {
                    FilePathEdit.Text += openFileDialog.FileNames[i] + ";";
                }
            }
            else
                FilePathEdit.Text = "";
        }

        private void StoreBtn_Click(object sender, EventArgs e)
        {
            string succeededFilesList = "";
            string failedFilesList = "";

            DCXREQ req = null;
            try
            {
                // Create the requester object
                req = new DCXREQ();

                // Send the files to the remote ae and recieve 
                // succeeded files list and the failed files list
                req.Send(LocalAEEdit.Text,
                         TargetAEEdit.Text,
                         HostEdit.Text,
                         ushort.Parse(PortEdit.Text),
                         FilePathEdit.Text,
                         out succeededFilesList,
                         out failedFilesList);

                MessageBox.Show("Succeeded files: \n" +
                                succeededFilesList + "\n" +
                                "Failed files: \n" +
                                failedFilesList);
            }
            catch (System.Runtime.InteropServices.COMException com_e)
            {
                MessageBox.Show("Send files failed");
            }
            finally
            {
                ReleaseComObject(req);
            }
        }

        
        /* This has to be called for all the com objects to release the
         memory!!! */
        private void ReleaseComObject(object o)
        {
            if (o != null)
                Marshal.ReleaseComObject(o);
        }
    }
}